(* ==================================================================
The use of this Package is described in "Economic and Financial
Modeling with Mathematica", Hal Varian, editor, TELOS/Springer-Verlag,
1993, ISBN 0-387-97882-8.  $44.95 (Includes 1.44 MS-DOS disk.)  To
place order call 1-800-777-4643 or fax 1-201-348-4505.
=====================================================================*)

(*^

::[	frontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.1";
	macintoshStandardFontEncoding; 
	paletteColors = 128; currentKernel; 
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L3, e8,  24, "Times"; ;
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L2, e6,  18, "Times"; ;
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L2, e6,  14, "Times"; ;
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, L2, a20,  14, "Times"; ;
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, B65535, L2, a15,  12, "Times"; ;
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, B65535, L2, a12,  12, "Times"; ;
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L2,  12, "Times"; ;
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L2,  10, "Times"; ;
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L2,  12, "Courier"; ;
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L2,  12, "Courier"; ;
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L2,  12, "Courier"; ;
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L2,  12, "Courier"; ;
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L2,  12, "Courier"; ;
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287, L2,  12, "Courier"; ;
	fontset = name, inactive, nowordwrap, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic, B65535, L2,  10, "Geneva"; ;
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7, L2,  10, "Times"; ;
	fontset = leftheader, inactive, L2,  10, "Times"; ;
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7, L2,  12, "Times"; ;
	fontset = leftfooter, inactive, center, L2,  12, "Times"; ;
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L2,  10, "Geneva"; ;
	fontset = clipboard, inactive, noKeepOnOnePage, preserveAspect, M7, L2,  12, "New York"; ;
	fontset = completions, inactive, nowordwrap, noKeepOnOnePage, preserveAspect, M7, L2,  12, "New York"; ;
	fontset = special1, inactive, nowordwrap, noKeepOnOnePage, preserveAspect, M7, L2,  12, "New York"; ;
	fontset = special2, inactive, nowordwrap, noKeepOnOnePage, preserveAspect, center, M7, L2,  12, "New York"; ;
	fontset = special3, inactive, nowordwrap, noKeepOnOnePage, preserveAspect, right, M7, L2,  12, "New York"; ;
	fontset = special4, inactive, nowordwrap, noKeepOnOnePage, preserveAspect, M7, L2,  12, "New York"; ;
	fontset = special5, inactive, nowordwrap, noKeepOnOnePage, preserveAspect, M7, L2,  12, "New York"; ;
]
:[font = subsubsection; inactive; Cclosed; dontPreserveAspect; startGroup; ]
Blank Cell Collection
:[font = input; dontPreserveAspect; endGroup; ]

Clear[ f ]

f::usage=""

Begin["PrivateF`"];

(* code *)

End[ (* Private *) ];

:[font = subsubsection; inactive; initialization; Cclosed; preserveAspect; startGroup; ]
Usage Messages.................................................................................12 Aug 91  ...   5 Aug  92
:[font = input; initialization; preserveAspect; endGroup; ]
*)
Protect[t,Z];  (* Save these symbols... *)

WeinerProcessMake::usage="WeinerProcessMake[s_Symbol] builds a Weiner
	process diffusion.  The procedure has no explicit result.";

DiffusionWeinerProcessMake::usage="DiffusionWeinerProcessMake[s_Symbol]
	builds a Weiner	process diffusion. The procedure has no explicit
	result and is an alias for WeinerProcessMake.";
	
	
DiffusionMake::usage="DiffusionMake[x_Symbol,wp_diffusion,f,g,x0] builds
	a diffusion	based on the Weiner process defined by wp.  The resulting
	diffusion has symbolic name x and the drift and dispersion functions
	f and g, respectively.  x0 is the intended intial value.
	The procedure has no explicit result.";

diffusion::usage="Internal data structure for holding the contents
	of a diffusion object.";
	

DiffusionLabel::usage="DiffusionLabel[d_diffusion] returns the
	text name of the diffusion d.";
	
DiffusionSymbol::usage="DiffusionSymbol[d_diffusion] returns the
	symbolic name of the diffusion d wrapped in HoldForm to avoid
	evaluation recursion.";
	
DiffusionDrift::usage="DiffusionDrift[d_diffusion] returns the drift
	function of	the	diffusion d. DiffusionDrift[d_diffusion,Function]
	returns a function object.";

DiffusionDispersion::usage="DiffusionDispersion[d] returns the dispersion
	function of	the	diffusion d. DiffusionDispersion[d_diffusion,Function]
	returns a function object.";
	
DiffusionInitialValue::usage="DiffusionInitialValue[d_diffusion] returns
	the initial value of the diffusion d.";

DiffusionPrint::usage = "DiffusionPrint[d] prints a formatted version
	of the diffusion object d using subscripts and symbolic names.";
	
DiffusionExpand::usage = "DiffusionExpand[expr] attempts to combine
	the diffusion elements in the input expression into a single
	diffusion with simple algebraic operations.";
	
DiffusionSimulate::usage="DiffusionSimulate[d_diffusion, n, dt] simulates a
	diffusion.  It returns a list of n pairs {,,,{i*dt,x[i*dt]},,,} of the
	diffusion d. Each realized series is an independent realization.
	Responds with an error if the diffusion contains symbolic paramters.";

DiffusionA::usage = "DiffusionA[expr] is an alias for A[d][expr].";

A::usage = "A[expr] applies the infinitesimal operator
	associated with the diffusion d to the expression expr.";

DiffusionIto::usage = "DiffusionIto[expr] is an alias for
	Ito[expr].";
	
Ito::usage = "Ito[expr] finds the diffusion that results
	from the scalar expression which is assumed to contain
	a diffusion.  Options: 
			'itoInvert -> True' --> default
			'itoSymbol -> Y   ' --> symbol for new process.";

ItoInvert::usage="If true (default), attempts to symbolically find
	the inverse diffusion.";
	
ItoSymbol::usage="New symbol denoting the diffusion created by 
	applyinhg the Ito formula.";

(*
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup; ]
Some replacement utilities.............................................................. 29 Jul 92  ...   2 Sept 92
:[font = text; inactive; preserveAspect; ]
Replacement utilities:
These functions replace the diffusion[___] object by the Held symbol associated with the diffusion or some other symbol of choice.

The last variation allows both the diffusion and its held symbol to both be replaced at once.
;[s]
2:0,1;22,0;249,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; preserveAspect; endGroup; ]
*)
Clear[findDiffusion, replaceDiffusion, replaceHeld];

	findDiffusion::tooFew =
		 "This expression does not contain a diffusion.";
	findDiffusion::tooMany =
		 "This expression has more than one diffusion.";

	findDiffusion[expr_] := Module	\
		[	{found, len},
			found = Cases[expr, _diffusion, Infinity];
			len = Length[found];
			If[ len == 0, Message[findDiffusion::tooFew]; Return];
			If[ len > 1 , Message[findDiffusion::tooMany]; Return];
			First[found]
		]
				
	replaceDiffusion[expr_] :=
			expr /. d_diffusion :> DiffusionSymbol[d]; 
			
	replaceDiffusion[expr_,d_diffusion] := 
			expr /. d -> DiffusionSymbol[d]
					 
	replaceDiffusion[expr_,d_diffusion,sub_] := Module	\
		[	{hf = DiffusionSymbol[d]},
			expr /. {d -> sub, hf -> sub}
		]

	replaceHeld[expr_,str_,sym_Symbol] := 
			expr /. (HoldForm @@ ToHeldExpression[str]) -> sym
(*
:[font = subsubsection; inactive; initialization; Cclosed; dontPreserveAspect; startGroup; ]
Creating and identifying diffusions................................................8 Aug 91  ... 30 Aug 92
:[font = text; inactive; initialization; preserveAspect; ]
Data Structure Notes:
Diffusions are lists with head diffusion.  The contents of the list are the
     (1) HoldForm of the symbol used to define the diffusion,
     (2) HoldForm of the underlying Weiner process (Brownian motion),
     (3) drift and dispersion functions with the diffusion in question held, and
     (4) initial value, again with a held diffusion symbol.
HoldForm avoids infinite recursion yet gives a reasonable printed form.  Notice that Weiner processes have identical first and second elements, since the underlying Weiner process is in fact the same process.
;[s]
2:0,1;21,0;580,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; dontPreserveAspect; ]
*)
Clear[DiffusionMake, WeinerProcessMake, DiffusionChangeSymbol];

WeinerProcessMake[var_Symbol] := Module \
	[ 	{},
		Set[var, diffusion[HoldForm[var],HoldForm[var],0,1,0]];
	]

DiffusionMake[var_Symbol,diffusion[wp_,wp_,___], f_,g_,initial_:0] := Module \
	[	{drift, disp, iv},
		drift = f /. var -> HoldForm[var];
		disp  = g /. var -> HoldForm[var];
		iv    = initial /. var -> HoldForm[var];
		Set[var, diffusion[HoldForm[var],wp,drift,disp,iv]];
	]
	
DiffusionChangeSymbol[diffusion[x_,wp_,f_,g_,i_], new_Symbol] :=
	Module[ {},
		DiffusionMake[new,ReleaseHold[wp],
					f/.x->new,g/.x->new,i/.x->new];
		new];
(*
:[font = text; inactive; preserveAspect; ]
Logical Tests:
;[s]
1:0,1;15,-1;
2:0,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; preserveAspect; ]
Clear[DiffusionQ, HasHeldDiffusionQ]

DiffusionQ[x_diffusion] := True
DiffusionQ[_] := False

HasHeldDiffusionQ[_Symbol] := False;
HasHeldDiffusionQ[_?NumberQ] := False;
HasHeldDiffusionQ[HoldForm[_?DiffusionQ]] := True
HasHeldDiffusionQ[expr_] := 
		And @@ HasHeldDiffusionQ /@
			Cases[expr,HoldForm[_],Infinity]
HasHeldDiffusionQ[_] := False
:[font = text; inactive; initialization; dontPreserveAspect; ]
Algebraic operations:
Once diffusions are used in algebraic expressions, all are elevated to symbolic "HoldForm" status.  These rules force the diffusion objects to adopt a common form, which by default is of the held symbolic type.  Only a sum of two diffusions permits a combination.  
;[s]
2:0,1;22,0;288,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
Clear[diffusion, diffusionNewName, DiffusionExpand]


diffusionNewName := HoldForm[Evaluate[Unique[]]]

DiffToSymbolsQ = True;

Attributes[DiffusionExpand] = {HoldAll};

DiffusionExpand[expr_] := Block	\
	[	{res},
		DiffToSymbolsQ = False;
		res = Release[expr] //. DiffusionExpandRules;
		DiffToSymbolsQ = True;
		res
	]

DiffusionExpandRules = 
	{ k_?NumberQ * diffusion[_,w_,mu_,sig_,x0_] -> 
			diffusion[diffusionNewName,w,k mu, k sig, k x0],
	  k_Symbol   * diffusion[_,w_,mu_,sig_,x0_] -> 
			diffusion[diffusionNewName,w,k mu, k sig, k x0],
	  diffusion[_,w_,m1_,s1_,x01_] + diffusion[_,w_,m2_,s2_,x02_] ->
	  		diffusion[diffusionNewName,w,m1+m2,s1+s2,x01+x02] };


diffusion /:  k_ * d_diffusion :=
					k * DiffusionSymbol[d] /; DiffToSymbolsQ;
					
diffusion /:  k_ + d_diffusion :=
					k + DiffusionSymbol[d] /; DiffToSymbolsQ;
					
diffusion /:  f_[d_diffusion,t_] := 
				DiffusionSymbol[f] @@ {DiffusionSymbol[d],t} /;
					(Head[f]===diffusion) && DiffToSymbolsQ;
(*
:[font = subsubsection; inactive; initialization; autoActive; Cclosed; dontPreserveAspect; startGroup; ]
Accessing diffusions.........................................................................8 Aug 91  ...  30 Aug 92
:[font = input; initialization; dontPreserveAspect; ]
*)
Clear[DiffusionSymbol,
	  DiffusionWeinerProcess, DiffusionWeinerProcessSymbol,
	  DiffusionDrift,
	  DiffusionDispersion, DiffusionInitialValue];
	  
Begin["PrivateDiffAccess`"];
(*
:[font = text; inactive; initialization; preserveAspect; ]
Accessors:
Pattern matching gives the most direct extraction from the list so one can avoid, for example, indexing.  The only elegance here comes in building the pure functions for the drift and the dispersion functions.  First once has to get the symbol that identifies the diffusion.  This gives a Hold[ ] expression, and then @@ replaces the head of this guy with HoldForm, as it appears in the data structure.
;[s]
2:0,1;11,0;414,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; dontPreserveAspect; ]
*)
DiffusionWeinerProcess [diffusion[_,wp_,___]]  := ReleaseHold[wp]

DiffusionSymbol[diffusion[l_,___]] := l;
DiffusionWeinerProcessSymbol[diffusion[_,wp_,___]] :=
		DiffusionSymbol[ReleaseHold[wp]];


DiffusionDrift[diffusion[_,_,f_,___]]  := f;
DiffusionDrift[d_diffusion, Function] := 
	Function[{x,t}, Release[replaceDiffusion[DiffusionDrift[d],d,x]]  ]

DiffusionDispersion[diffusion[_,_,_,s_,___]]  := s;
DiffusionDispersion[d_diffusion, Function] := 
	Function[{x,t}, Release[replaceDiffusion[DiffusionDispersion[d],d,x]]  ]
	
DiffusionInitialValue[diffusion[_,_,_,_,iv_]]:= iv;
	
(*
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
End[ (* PrivateDiffAccess *) ];
(*
:[font = subsubsection; inactive; initialization; Cclosed; dontPreserveAspect; startGroup; ]
Printing diffusions.......................................................................... 31 Jul 92 ...   15 Sept 92
:[font = text; inactive; initialization; dontPreserveAspect; ]
Diffusions are printed in a "nice" format automatically.  The symbolic names are used, with automatically added subscripts.
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
Clear[DiffusionPrint, diffPrint];

diffPrint[x_,w_,f_,g_,i_] := diffPrint[x,w,f,g,i,x]

diffPrint[x_,w_,f_,g_,i_,alias_] := 
	Module[{xt = SequenceForm[alias,Subscript["t"]],
		    x0 = SequenceForm[alias,Subscript["0"]],
		    ft,gt},
		ft = f /. x -> xt;
		gt = g /. x -> xt;
		If [ NumberQ[gt] && gt == 0,
			Print["d",xt," = ",ft," dt","  ; ",x0," = ",i],
		(* Else non trivial dispersion *)
			Print["d",xt," = ",
				  ft," dt + ",gt," d",w,Subscript["t"],"  ; ",
				  x0," = ",i]
		];
	];


DiffusionPrint[diffusion[lab_,lab_,f_,g_,i_]] := Module \
	[	{},
		Print[lab, Subscript["t"],
			" = Weiner Process with scale ",g];
	]

DiffusionPrint[diffusion[x_,wp_,f_,g_,i_]] := 
	diffPrint[x,wp,f,g,i];
	
DiffusionPrint[diffusion[x_,wp_,f_,g_,i_],alias_String] :=
	diffPrint[x,wp,f,g,i,alias];
(*
:[font = subsubsection; inactive; initialization; autoActive; Cclosed; dontPreserveAspect; startGroup; ]
Simulations of diffusions................................................................11 Aug 91 ...   5 Aug 92
:[font = input; initialization; dontPreserveAspect; ]
*)
Clear[DiffusionSimulate]

Begin["PrivateDiffSimulate`"];
(*
:[font = input; initialization; dontPreserveAspect; ]
*)
Clear[nRandom]
	nRandom[sigma2_] := 		(* single N[0,sigma2] *)
		N[ Sqrt[-sigma2 2 Log[ Random[] ]] Cos[Random[Real,{0,2 N[Pi]}]]];

	nRandom[sigma2_, n_] := 	(* list of n N[0,sigma2] *)
		N[ Sqrt[-sigma2 2 Log[Table[Random[],{n}]]]
		   Cos[Table[Random[Real,{0, 2 N[Pi]}],{n}]]];
	
DiffusionSimulate::symbolic = 
	"This diffusion contains non-numeric parameters.";

DiffusionSimulate[diffusion[w_,w_,_,_,iv_], n_, dt_:0.01] := Module \
[	{i},
	Transpose[{ Table[i*dt,{i,0,n-1}],
			  FoldList[Plus,iv,nRandom[dt,n-1]] }
	]
]
	
DiffusionSimulate[d_diffusion, n_, dt_:0.01] := Module		\
[	{x,mu,sigma,sym,x0, mQ,sQ,xQ, dW, i=0},
	nextValue[{time_,current_}] := Module	\
	[	{dm,db},
		i  = i + 1;
		dm = mu[current,time] dt;
		db = sigma[current,time] dW[[i]];
		(* Print["dt ",dt," db ",db]; *)
		{time+dt,current+dm+db} // N
	];
	mu    = DiffusionDrift[d,Function];
	sigma = DiffusionDispersion[d,Function];
	x0    = N[DiffusionInitialValue[d]];
	mu11    = mu[1,1];	(* simple test for symbolic presence *)
	sigma11 = sigma[1,1];
	{mQ,sQ,xQ} = {NumberQ[mu11], NumberQ[sigma11], NumberQ[x0]};
	If[ mQ && sQ && xQ,
		 dW    = nRandom[dt,n];
		 NestList[nextValue,{0,x0},n-1],
	(* Else *)
		 Message[DiffusionSimulate::symbolic];
		 Print["mu[1,1] = ", mu11, ";  sigma[1,1] = ",sigma11,
		 	   ";  x0 = ",x0];
	]
];
(*
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
End[ (* "PrivateDiffSimulate`" *) ];
(*
:[font = subsubsection; inactive; Cclosed; dontPreserveAspect; startGroup; ]
Infinitesimal generator of a diffusion............................................. 1 Aug 91 ...  31 Jul 92
:[font = text; inactive; dontPreserveAspect; ]
Infinitesimal generator:
The infinitesimal of a diffusion characterizes both its local drift properties as thus is an important component of the Ito formula developed in a following cell.
;[s]
2:0,1;24,0;188,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
Clear[A, DiffusionA, OperatorA];

DiffusionA[expr_] := A[expr];

A[expr_] := OperatorA[findDiffusion[expr]][expr];

OperatorA[d_diffusion][expr_] := Module	\
	[ {drift,disp, fd,sd, ggp,dt,xt,e=expr},
		e = expr /. d -> xt;
		drift = replaceDiffusion[DiffusionDrift[d],d,xt];
		disp  = replaceDiffusion[DiffusionDispersion[d],d,xt];
		fd  = D[e,xt];
		sd  = D[fd,xt];
		(* Print ["Drift ------>", drift," . ", fd]; *)
		(* Print ["Dispersion-->", disp," . ",disp,"' . ",sd]; *)
		drift= drift fd;
		disp = 1/2 disp disp sd;
		dt = D[e,Global`t];
		(* Print["Final three components"]; *)
		(* Print[drift, " + " , disp, " + ", dt]; *)
		Simplify[drift + disp + dt] /. xt -> DiffusionSymbol[d]
	];
(*
:[font = subsubsection; inactive; Cclosed; dontPreserveAspect; startGroup; ]
Ito's Formula for a diffusion via the infinitesimal....................... 28 Sep 91 ...  31 Jul 92
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
Clear[Ito, OperatorIto, DiffusionIto, ItoInvert, ItoSymbol];
	
Options[Ito] = {ItoInvert->True, ItoSymbol->Z};

Ito[expr_, opts___Rule] := OperatorIto[findDiffusion[expr]][expr, opts];

DiffusionIto[expr_,opts___Rule] := Ito[expr,opts];

OperatorIto[d_diffusion][expr_, opts___Rule] := Module	\
	[ {drift, disp, e, xt, dSymbol, wp, invRules, ns, invert, start},
		dSymbol = DiffusionSymbol[d];
		wp = DiffusionWeinerProcess[d];
		e = replaceDiffusion[expr,d,xt];
		drift = OperatorA[d][expr] /. dSymbol -> xt;
		disp  = D[e,xt] (DiffusionDispersion[d] /. dSymbol -> xt);
		(* Print["Drift with xt ", drift,";   Disp with xt ", disp]; *)
		Print["d",e /. xt->dSymbol," = (",
				drift /. xt->dSymbol,") dt + (",
				disp /. xt->dSymbol,
				") d",DiffusionSymbol[wp],Subscript[t]];
		invert = ItoInvert /. {opts}  /. Options[Ito]; 
		If[invert,
			ns = ItoSymbol /. {opts} /. Options[Ito];
			(* Print["Solving ", ns, "  ==  ", e/.xt -> dSymbol]; *)
			invRules = First[Solve[ns==e,xt]];
			Print["Inversion rule... ", invRules /. xt -> dSymbol];
			(* Substitute in the drift and dispersion functions *)
			drift = drift /. invRules; drift=Simplify[drift];
			disp  = disp /. invRules; disp=Simplify[disp],
		(* Else *)
			ns = Head[expr];
		];
		(* Fix the starting location *)
		start = e/.xt->DiffusionInitialValue[d];
		(* Make the new diffusion in the global context *)
		If[ns===Z, Unprotect[Z]; Clear[Z]];
		DiffusionMake[ns,wp,drift/.xt->dSymbol,disp/.xt->dSymbol,start];
		Protect[Z];
		ns
	];
(*
:[font = subsubsection; inactive; Cclosed; dontPreserveAspect; startGroup; ]
Feynman-Kac Formula.................................................................... 11 Aug 91  ... 15 Sep 92
:[font = input; initialization; dontPreserveAspect; ]
*)
Clear[FeynmanKac, T, Infinitesimal];

DiffusionFeynmanKac::usage = "DiffusionFeynmanKac[pde, bv] is an
	alias for Feynman-Kac.";
	
FeynmanKac::usage="FeynmanKac[pde, bv] attempts to solve the pde
	represented by the first argument using the Feynman-Kac
	theorem.  The result, if successful, is an expectation over
	a diffusion.  Solution assumes interval [0,T].";
	
FeynmanKac::fails = "Could not solve this PDE via Feynman-Kac.";
(*
:[font = text; inactive; preserveAspect; ]
Infinitesimal Rules:
Infinitesimal rules attempt to locate the infinitesimal of a function within an expression, replacing the appropriate structure with an expression having head 'Infinitesimal'.  This set of rules ASSUMES that the expression is normalized to have the coef of D[f[x,t],t] set to 1.
;[s]
2:0,1;20,0;300,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; dontPreserveAspect; ]
*)
Clear[InfRules]

InfRules = 	\
{	D[f_[x_,t_],t_]+m_.D[f_[x_,t_],x_]+s_.D[f_[x_,t_],{x_,2}]:>
			Infinitesimal[m,PowerExpand[Sqrt[2 s]]][ f[x,t] ],
	D[f_[x_,t_],t_] +                  s_.D[f_[x_,t_],{x_,2}]:>
			Infinitesimal[0,PowerExpand[Sqrt[2 s]]][ f[x,t] ],
	D[f_[x_,t_],t_] + m_. D[f_[x_,t_],x_]                    ->
			Infinitesimal[m,     0   ][ f[x,t] ]
};
(*
:[font = text; inactive; preserveAspect; ]
	FK Rules:
FK rules use the substitution rules from the Feynman-Kac theorem to reduce an expression which contains an infinitesimal to a simpler form containing a diffusion.  The resulting expression has  head FK.  The diffusion generated by this substitution uses a Weiner process, denoted FKW.

;[s]
2:0,1;11,0;297,-1;
2:1,14,9,Times,0,12,0,0,0;1,14,9,Times,2,12,0,0,0;
:[font = input; initialization; dontPreserveAspect; endGroup; ]
*)
Clear[FKW, FeynmanKac];			WeinerProcessMake[FKW];

FKRules :=		\
{
Infinitesimal[m_,s_][f_[x_,t_]] - rho_[x_,t_] f_[x_,t_] + u_[x_,t_] ->
				FK[f,diffusion[x,HoldForm[W],m,s,0],rho[x,t],u[x,t]],
Infinitesimal[m_,s_][f_[x_,t_]] - rho_. f_[x_,t_] + u_[x_,t_] ->
				FK[f,diffusion[x,HoldForm[W],m,s,0],rho,u[x,t]],
Infinitesimal[m_,s_][f_[x_,t_]] - rho_[x_,t_] f_[x_,t_] + u_. ->
				FK[f,diffusion[x,HoldForm[W],m,s,0],rho[x,t],u],
Infinitesimal[m_,s_][f_[x_,t_]] - rho_. f_[x_,t_] + u_. ->
				FK[f,diffusion[x,HoldForm[W],m,s,0],rho,u],
Infinitesimal[m_,s_][f_[x_,t_]] - rho_. f_[x_,t_] ->
				FK[f,diffusion[x,HoldForm[W],m,s,0],rho,0],
Infinitesimal[m_,s_][f_[x_,t_]] ->
				FK[f,diffusion[x,HoldForm[W],m,s,0],0,0]
};

DiffusionFeynmanKac[pde_, bv_] := FeynmanKac[pde,bv];

FeynmanKac[pde_,bv_] :=  Module		\
	[ {step1, step2, f,d,r,u},
		step1 = pde   /. InfRules;
		step2 = step1 /. FKRules;
		If [ Head[step2] === FK,
			{f,d,r,u} = List @@ step2;
			Print["f = ",f,";  rho = ",r,";  u = ",u];
			d[[5]] = x;
			DiffusionPrint[d,"X"];
			Ave[Exp[-r (Global`T-t)]
				bv[HoldForm[X][Global`T-t]] ],
		(* Else *)
			Message [FeynmanKac::fails];
			{pde,bv}
		]
	];
(*
^*)